ctools - Change request #2310

Shorten ctools unit tests
02/12/2018 12:14 AM - Knodlseder Jirgen

Status: Closed Start date: 02/12/2018
Priority: Normal Due date:

Assigned To: Knédlseder Jurgen % Done: 100%
Category: Estimated time: 0.00 hour
Target version: 1.6.0

Description

The ctools unit tests are now quite long, and should be shortened for a more efficient testing. This may imply that some GammalLib
methods need to be accelerated. Below a list of unit tests that need special attention (times are for CentOS 6):

ctools:

e cterror (34 s)
e ctobssim (1 min 5s)
e pipeline (16 s)

cscripts:

¢ cslightcrv (32 s)

e csphagen (33 s)

e csphasecrv (1 min 51 s)
e cspull (31 s)

e csresspec (1 min 33 s)
e csspec (37 s)

e cstsdist (36 s)

e csworkflow (33 s)

History

#1 - 07/24/2018 11:55 AM - Knddlseder Jiirgen
- Status changed from New to In Progress

- Assigned To set to Knédlseder Jiirgen

Before reworking the unit tests, here the benchmark on CentOS 6:

e Examples: 15 s
e cscripts: 16 mn
e ctools:3mn54 s

#2 - 07/24/2018 12:35 PM - Knodlseder Jiirgen
- % Done changed from 0 to 10

After reducing the energy range in some csripts unit tests to 1-100 TeV and minimizing the number of bins, the following results are achieved:

e Examples: 17 s (nothing changed, i.e. change reflects uncertainty of timing measurement)

e cscripts: 10 mn

¢ ctools: 4 mn 23 s (nothing changed, i.e. change reflects uncertainty of timing measurement)

The unit test time was reduced from 16 minutes to 10 minutes, the full duration of the integration pipeline went from 56 min to 44 min.
#3 - 07/24/2018 03:44 PM - Knodlseder Jiirgen
- % Done changed from 10 to 50

| generated a shorter event list and a smaller counts cube and reduced the energy range and the cube dimension in the unit tests. Now the following
results are achieved:

e Examples: 17 s
® cscripts: 7mn 18 s
e ctools:3mn 29 s

The full duration of the integration pipeline went from 56 min to 36 min.
The longest cscripts tests are now (CentOS 6 benchmarks):

e cstsdist from Python in unbinned mode (1 mn 8 s)
csworkflow from Python (40 s)
cslightcrv from Python (38 s)
cstsdist on command line (38 s)
cstsdist pickeling (34 s)

csspec from Python (30 s)
csworkflow on command line (23 s)
csspec pickeling (20 s)

csphasecrv from Python (18 s)
csspec on command line (15 s)
csphagen from Python (15 s)
cslightcrv on command line (12 s)
csiactobs from Python (11 s)
cslighterv pickeling (11 s)

The longest ctools tests are now (CentOS 6 benchmarks):

e ctobssim from Python (1 mn5s)

e cterror from Python (43 s)

¢ unbinned pipeline with FITS file saving (18 s)
e ctobssim on command line (16 s)

® unbinned in-memory pipeline (16 s)

¢ cterror on command line (12 s)

¢ ctulimit from Python (12 s)

e cttsmap on command line (10 s)
#4 - 07/25/2018 10:41 AM - Knddlseder Jiirgen
- Status changed from In Progress to Closed

- % Done changed from 50 to 100

After some final tweaking, the following timing is obtained on CentOS 6:

e Examples: 14 s
e cscripts: 6 mn 54 s
e ctools:3mn 24 s

The total duration of the integration job took 33 minutes.
